#include "wapp.h"
#include <stdio.h>

typedef struct uuid4 UUID4;
struct uuid4 {
  u64 high;
  u64 low;
};

UUID4 gen_uuid4(XOR256State *state);
void stringify_uuid4(UUID4 uuid, char *dst, u64 len);

int main(void) {
  XOR256State state = wapp_init_xor_256_state();
  UUID4 uuid = gen_uuid4(&state);
  char buf[40] = {0};

  for (int i = 0; i < 1000; ++i) {
    UUID4 uuid = gen_uuid4(&state);
    stringify_uuid4(uuid, buf, 40);
    printf("%s\n", buf);
  }

  return 0;
}

UUID4 gen_uuid4(XOR256State *state) {
  UUID4 uuid = { .high = wapp_xorshift_256_generate(state), .low = wapp_xorshift_256_generate(state) };
  uuid.high = (uuid.high & 0xffffffffffff0fff) | 0x0000000000004000;
  uuid.low  = (uuid.low  & 0xbfffffffffffffff) | 0x8000000000000000;
  return uuid;
}

void stringify_uuid4(UUID4 uuid, char *dst, u64 len) {
  u64 a = uuid.high >> 32;
  u64 b = (uuid.high << 32) >> 48;
  u64 c = (uuid.high << 48) >> 48;
  u64 d = uuid.low >> 48;
  u64 e = (uuid.low << 16) >> 16;

  snprintf(dst, len, "%.8llx-%.4llx-%.4llx-%.4llx-%.12llx", a, b, c, d, e);
}
